#include <stdio.h>
#include <stdlib.h>
#include <mpi.h>
#include <math.h>
#include <assert.h>

int main( int argc, char *argv[] )
{
    double t1, t2, tick;
    int world_rank, world_size;
    float sum=0;
    int i1, i2, i3;

/*    MPI_Init(&argc, &argv); */
    MPI_Init(NULL, NULL);
    MPI_Comm_rank(MPI_COMM_WORLD, &world_rank);
    MPI_Comm_size(MPI_COMM_WORLD, &world_size);

    MPI_Barrier(MPI_COMM_WORLD); /* IMPORTANT */
    t1 = MPI_Wtime();
    tick = MPI_Wtick();

    sleep(1+world_rank);

    MPI_Barrier(MPI_COMM_WORLD); /* IMPORTANT */
    t2 = MPI_Wtime();

printf("process %d: MPI_Wtime %1.9f \n", world_rank, t2-t1);

    MPI_Barrier(MPI_COMM_WORLD);

    if(world_rank == 0){ /* use time on master node */

       printf("MPI_Wtime measured a time of %1.9f s.\n", t2-t1);
       printf("A single MPI tick is %0.9f seconds\n", tick);
       
      /* printf("MPI_WTIME_IS_GLOBAL  %d           \n", MPI_WTIME_IS_GLOBAL);
         The boolean variable MPI_WTIME_IS_GLOBAL, a predefined attribute key that 
         indicates whether clocks are synchronized, does not have a valid value in 
         Open MPI, as the clocks are not guaranteed to be synchronized.
       */

       fflush(stdout);
    }

    MPI_Finalize( );
    return 0;
}

